#!/usr/bin/env sh
#
# ----------------------------------------------------------------------------
#
# Copyright 2019 IBM Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# ----------------------------------------------------------------------------
#

set -eu

die() { echo "$*" >&2 ; exit 1 ; }

rm -rf chop.db

test=$(printenv test)
chop=$(printenv chop)
testbin=$(printenv testbin)
testdir=$(printenv testdir)

echo "> chop disasm $test"
"$chop" disasm "$testbin"

echo "> checking database"
test "$($chop list modules | wc -l)" -gt 0
test "$($chop list functions | wc -l)" -gt 0
test "$($chop list blocks | wc -l)" -gt 0

test_block_count() {
    name=$1 ; min=$2 ; max=$3
    sqlite3 chop.db > blocks << EOM
SELECT * FROM block INNER JOIN func
    ON block.func_id = func.rowid
WHERE func.name = "$name";
EOM
    num_blocks=$(wc -l < blocks)
    echo "Num_blocks detected in $name: $num_blocks"
    test "$num_blocks" -ge "$min" \
        || die "Error: $name has less than $min basic blocks ($num_blocks)"
    test "$num_blocks" -le "$max" \
        || die "Error: $name has more than $max basic blocks ($num_blocks)"
}

# shellcheck disable=SC1090,SC1091
. "$testdir/disasm.spec"
